searchNodes=[{"doc":"","ref":"Filtery.html","title":"Filtery","type":"module"},{"doc":"Filtery help you to build the query using a syntax which is similar to Mongo like this: filter = %{ status : &quot;active&quot; , email : { :not , nil } , role : [ &quot;admin&quot; , &quot;moderator&quot; ] } Filtery . apply ( User , filter ) The result is a query like this: from ( u in User , where : u . status == &quot;active&quot; and not is_nil ( u . email ) and u . role in [ &quot;admin&quot; , &quot;moderator&quot; ] ) Syntax You can use &lt;field&gt;: &lt;value&gt; expressions to specify the equality condition and query operator expressions. %{ &lt; field1 &gt; : &lt; value1 &gt; , &lt; field2 &gt; : { &lt; operator &gt; , &lt; value &gt; } , ... } All fields which field name starts with _ is ignored. Notes: all operator belows are reserved keywords and cannot be used as field name Supported operator Name Description :eq Matches values that are equal to a specified value. :gt Matches values that are greater than a specified value. :gte Matches values that are greater than or equal to a specified value. :in Matches any of the values specified in an array. :lt Matches values that are less than a specified value. :lte Matches values that are less than or equal to a specified value. :ne Matches all values that are not equal to a specified value. :nin Matches none of the values specified in an array. Logical operator Name Description :and Joins query clauses with a logical AND returns all documents that match the conditions of both clauses. :not Inverts the effect of a query expression and returns documents that do not match the query expression. :or Joins query clauses with a logical OR returns all documents that match the conditions of either clause. AND operator By default, if a map or keyword list is given, Filtery will join all field condition of that map using AND Filtery . apply ( User , %{ status : &quot;active&quot; , age : { :gt , 20 } } ) # same with Filtery . apply ( User , %{ and : %{ status : &quot;active&quot; , age : { :gt , 20 } } } ) # same with Filtery . apply ( User , %{ and : [ status : &quot;active&quot; , age : { :gt , 20 ] } } ) # same with from ( u in User , where : u . status == &quot;active&quot; and u . age &gt; 20 ) OR operator The :or operator performs a logical OR operation on an array of two or more &lt;expressions&gt; Filtery . apply ( Product , %{ or : %{ price : { :gt , 20 } , category : &quot;sport&quot; } } ) NOT operator Performs a logical NOT operation on the specified &lt;operator-expression&gt; Syntax : %{ field: %{ not: &lt;operator-expression&gt; } } Filtery . apply ( Product , %{ or : %{ price : { :gt , 20 } , category : { :not : &quot;sport&quot; } } } ) Filtery . apply ( Product , %{ or : %{ price : { :not , { :gt , 20 } } , category : &quot;sport&quot; } } ) 3. Extra operator Filtery provides some more useful operators to work with text and range. Name Description :between Matches values &gt; lower bound and &lt; upper bound :ibetween Matches values &gt;= lower bound and &lt;= upper bound like , contains Match values which contains specific value ilike , icontains Case insensitive version of like has For array type column, Matches array which has specific value Syntax between | ibetween Syntax : field: {:between, [lower_value, upper_value]} Check NULL and skip nil filter By default is a value in the filter is nil , Filtery applies is_nil to check NULL value. You can tell Filtery to ignore all nil field by passing skip_nil: true to the options Filtery . apply ( query , filter , skip_nil : true ) In that case, if you want to check field which is NULL or NOT NULL you use :is_nil instead of nil when passing value to the filter: Filter . apply ( query , %{ email : :is_nil } , skip_nil : true ) Define your operators You can extend Filtery and define your own operator. For example, here I define a new operatory equal defmodule MyFiltery do use Filtery.Base def filter ( column , { :equal , value } ) do dynamic ( [ q ] , field ( q , ^ column ) == ^ value ) end end To support a filter, you must follow this spec @spec filter ( column :: atom ( ) , { operator :: atom ( ) , value :: any ( ) } ) :: Ecto.Query . dynamic ( ) Within the body of filter/2 function using dynamic to compose your condtion and return a dynamic V. Joining tables Filtery defines a special operator ref to join table Syntax : &lt;field&gt;: {:ref, &lt;qualifier&gt;, &lt;filter on joined table&gt;} If qualifier is skipped, then :inner join is used by default. query = Filtery . apply ( Post , %{ comments : { :ref , %{ approved : true , content : { :like , &quot;filtery&quot; } } } } ) And then you can use Name binding to do further query query = where ( query , [ comments : c ] , c . published_at &gt; ^ xday_ago ) Qualifiers By default Filtery join using :inner qualifier. You can use one of `:inner , :left , :right , :cross , :full , :inner_lateral or :left_lateral qualifier as defined by Ecto. ### You can filter with nested ref elixir Filtery.apply(Post, %{comments: {:ref, %{ approved: true, user: {:ref, %{ name: {:like, &quot;Tom&quot;} }} }}}) ### Important Notes on ref operator - Field name must be the association name in your schema because Filtery use assoc to build join query. In the above example, Post schema must define association has_many: :comments, Comment - Not allow 2 ref with same name because the name is used as alias :as in join query, so it can only use one.","ref":"Filtery.html#apply/3","title":"Filtery.apply/3","type":"function"},{"doc":"Apply filter on single column If filter value is list, filter row that match any value in the list","ref":"Filtery.html#filter/2","title":"Filtery.filter/2","type":"function"},{"doc":"","ref":"Filtery.html#filter/3","title":"Filtery.filter/3","type":"function"},{"doc":"","ref":"Filtery.html#join_ref/3","title":"Filtery.join_ref/3","type":"function"},{"doc":"","ref":"Filtery.Base.html","title":"Filtery.Base","type":"module"},{"doc":"Filtery Filtery help you to build the query using a syntax which is similar to Mongo This is super useful when you want to build filter from request params. filter = %{ status : &quot;active&quot; , email : { :not , nil } , role : [ &quot;admin&quot; , &quot;moderator&quot; ] } Filtery . apply ( User , filter )","ref":"readme.html","title":"Filtery","type":"extras"},{"doc":"Add filtery to your list of dependencies in mix.exs : def deps do [ { :filtery , &quot;~&gt; 0.2&quot; } ] end Documentation is published here https://hexdocs.pm/filtery . Table of Contents Installation I. Usage II. Syntax III. Supported operator 1. Comparition operator 2. Logical operator 3. Extra operator 4. Check NULL and skip nil filter IV. Define your operators V. Joining tables &lt;!-- markdown-toc end --&gt;","ref":"readme.html#installation","title":"Filtery - Installation","type":"extras"},{"doc":"Filtery help you to build the query using a similar syntax with MongoDB like this: filter = %{ status : &quot;active&quot; , email : { :not , nil } , role : [ &quot;admin&quot; , &quot;moderator&quot; ] } Filtery . apply ( User , filter ) The result is a query like this: from ( u in User , where : u . status == &quot;active&quot; and not is_nil ( u . email ) and u . role in [ &quot;admin&quot; , &quot;moderator&quot; ] )","ref":"readme.html#i-usage","title":"Filtery - I. Usage","type":"extras"},{"doc":"You can use &lt;field&gt;: &lt;value&gt; expressions to specify the equality condition and query operator expressions. %{ &lt; field1 &gt; : &lt; value1 &gt; , &lt; field2 &gt; : { &lt; operator &gt; , &lt; value &gt; } , ... } Notes: all operator belows are reserved keywords and cannot be used as field name","ref":"readme.html#ii-syntax","title":"Filtery - II. Syntax","type":"extras"},{"doc":"1. Comparition operator :eq Matches values that are equal to a specified value. :gt Matches values that are greater than a specified value. :gte Matches values that are greater than or equal to a specified value. :in Matches any of the values specified in an array. :lt Matches values that are less than a specified value. :lte Matches values that are less than or equal to a specified value. :ne Matches all values that are not equal to a specified value. :nin Matches none of the values specified in an array. 2. Logical operator Name Description :and Joins query clauses with a logical AND returns all documents that match the conditions of both clauses. :not Inverts the effect of a query expression and returns documents that do not match the query expression. :or Joins query clauses with a logical OR returns all documents that match the conditions of either clause. AND operator By default, if a map or keyword list is given, Filtery will join all field condition of that map using AND Filtery . apply ( User , %{ status : &quot;active&quot; , age : { :gt , 20 } } ) # same with Filtery . apply ( User , %{ and : %{ status : &quot;active&quot; , age : { :gt , 20 } } } ) # same with Filtery . apply ( User , %{ and : [ status : &quot;active&quot; , age : { :gt , 20 ] } } ) # same with from ( u in User , where : u . status == &quot;active&quot; and u . age &gt; 20 ) OR operator The :or operator performs a logical OR operation on an array of two or more &lt;expressions&gt; Filtery . apply ( Product , %{ or : %{ price : { :gt , 20 } , category : &quot;sport&quot; } } ) NOT operator Performs a logical NOT operation on the specified &lt;operator-expression&gt; Syntax : %{ field: %{ not: &lt;operator-expression&gt; } } Filtery . apply ( Product , %{ or : %{ price : { :gt , 20 } , category : { :not : &quot;sport&quot; } } } ) Filtery . apply ( Product , %{ or : %{ price : { :not , { :gt , 20 } } , category : &quot;sport&quot; } } ) 3. Extra operator Filtery provides some more useful operators to work with text and range. Name Description :between Matches values &gt; lower bound and &lt; upper bound :ibetween Matches values &gt;= lower bound and &lt;= upper bound like , contains Match values which contains specific value ilike , icontains Case insensitive version of like has For array type column, Matches array which has specific value Syntax between | ibetween Syntax : field: {:between, [lower_value, upper_value]} Check NULL and skip nil filter By default is a value in the filter is nil , Filtery applies is_nil to check NULL value. You can tell Filtery to ignore all nil field by passing skip_nil: true to the options Filtery . apply ( query , filter , skip_nil : true ) In that case, if you want to check field which is NULL or NOT NULL you use :is_nil instead of nil when passing value to the filter: Filter . apply ( query , %{ email : :is_nil } , skip_nil : true )","ref":"readme.html#iii-supported-operator","title":"Filtery - III. Supported operator","type":"extras"},{"doc":"You can extend Filtery and define your own operator. For example, here I define a new operatory equal defmodule MyFiltery do use Filtery.Base def filter ( column , { :equal , value } ) do dynamic ( [ q ] , field ( q , ^ column ) == ^ value ) end end To support a filter, you must follow this spec @spec filter ( column :: atom ( ) , { operator :: atom ( ) , value :: any ( ) } ) :: Ecto.Query . dynamic ( ) Within the body of filter/2 function using dynamic to compose your condtion and return a dynamic","ref":"readme.html#iv-define-your-operators","title":"Filtery - IV. Define your operators","type":"extras"},{"doc":"Filtery defines a special operator ref to join table Syntax : &lt;field&gt;: {:ref, &lt;qualifier&gt;, &lt;filter on joined table&gt;} If qualifier is skipped, then :inner join is used by default. query = Filtery . apply ( Post , %{ comments : { :ref , %{ approved : true , content : { :like , &quot;filtery&quot; } } } } ) And then you can use Name binding to do further query query = where ( query , [ comments : c ] , c . published_at &gt; ^ xday_ago ) Qualifiers By default Filtery join using :inner qualifier. You can use one of `:inner , :left , :right , :cross , :full , :inner_lateral or :left_lateral qualifier as defined by Ecto. ### You can filter with nested ref elixir Filtery.apply(Post, %{comments: {:ref, %{ approved: true, user: {:ref, %{ name: {:like, &quot;Tom&quot;} }} }}}) ### Important Notes on ref operator - Field name must be the association name in your schema because Filtery use assoc to build join query. In the above example, Post schema must define association has_many: :comments, Comment - Not allow 2 ref with same name because the name is used as alias :as in join query, so it can only use one.","ref":"readme.html#v-joining-tables","title":"Filtery - V. Joining tables","type":"extras"}]